
! gfortran -Wall -fbounds-check expnoise.f95  -lcfitsio && rm -f *.fits *.png hist_* && ./a.out && for A in *.fits; do ~/fitspng/fitspng -fl 0,5 -o ${A%fits}png $A; done

program expnoise

  implicit none

  integer, parameter :: ndim = 120
  integer, dimension(ndim,ndim) :: obr
  real, dimension(ndim,ndim) :: robr
  integer, dimension(0:4000) :: hist
  real,dimension(2) :: r
  integer :: status,i,j,t,dt,n
  integer, dimension(2) :: naxes = (/ndim,ndim/)
  character(len=99) :: name,buf
  real :: mean, sig

  status = 0
  obr = 0

  do t = 1,3000

     do dt = 1,ndim*ndim

        call random_number(r)
        r = ndim*r + 1.0
        i = r(1)
        j = r(2)
        obr(i,j) = obr(i,j) + 1

        call random_number(r)
        i = 50 + invdist(r(1))
        j = 50 + invdist(r(2))
!        if( 1 < i .and. i < ndim .and. 1 < j .and. j < ndim ) &
!             obr(i,j) = obr(i,j) + 1

     end do

     mean = real(sum(obr))/real(ndim*ndim)
     sig = sqrt(real(sum((obr-mean)**2))/real(ndim*ndim-1))
     write(*,*) t,mean,sig

     goto 44

     write(name,'(a,i0,a)') 'exp_',t,'.fits'
     call ftinit(26,name,1,status)
     call ftphps(26,-32,2,naxes,status)
     call ftp2dj(26,1,ndim,ndim,ndim,obr,status)
     call ftclos(26,status)

     write(name,'(a,i0,a)') 'rexp_',t,'.fits'
     call ftinit(26,name,1,status)
     call ftphps(26,-32,2,naxes,status)
     robr = real(obr) / real(t)
     call ftp2de(26,1,ndim,ndim,ndim,robr,status)
     call ftclos(26,status)

     if( status /= 0 ) then
        call ftgmsg(buf)
        write(*,*) trim(buf)
        stop
     end if

     hist = 0
     do i = 1, ndim
        do j = 1,ndim
           n = obr(i,j)
           if( 0 < n .and. n < size(hist) ) then
              hist(n) = hist(n) + 1
           end if
        end do
     end do
     
     write(name,'(a,i0,a)') 'hist_',t,'.dat'

     open(15,file=name)
     do n = 0,size(hist)-1
        write(15,*) n,hist(n)
     end do
     close(15)

     44 continue
  
  end do


contains

  function invdist(xx)

    real :: invdist,xx

    ! inverzni fce k distribucni fci Gaussova rozdeleni
    ! s presnosti vetsi jak 0.00045
    
    real :: w,f,x
    logical :: interval

    x = xx
    if( x < 0.0 ) then
       invdist = 0.0
    elseif( x > 1.0 )then
       invdist = 1.0
    else
       interval = x < 0.5
       if( .not. interval ) x = 1.0 - x + epsilon(1.0)
       w = sqrt(-2.0*log(x));
       f = -w + (2.515517 + w*(0.802853 + w*0.010328))/ &
            (1.0 + w*(1.432788 + w*(0.189269 + w*0.001308)));
       if( interval ) then
          invdist = f
       else
          invdist = -f
       endif
    endif
    
  end function invdist


end program expnoise
